//  The file MUSDAspectFlipUp.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package memoryGame.aspects;

import memoryGame.classes.*;
import java.util.ArrayList;
import musd.runtime.lib.*;


public aspect MUSDAspectFlipUp extends MUSDAspect
{


	//Constants for instances, locations and varaibles
	static final int MemoryCard_INST_mc1 = 0;
	static final int MemoryPanel_INST_memoryPanel = 1;


	MUSDAspectFlipUp()
	{
		addMinimalEvent(MUSDMethods.env_MemoryCard_mouseClicked);
		numberOfLifeLines = 3;
		numberOfInstances = 2;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut env_MemoryCard_mouseClicked(MemoryCard memoryCard):
		execution(void MemoryCard.mouseClicked(..))
		&& target(memoryCard) ;

	after(MemoryCard memoryCard):env_MemoryCard_mouseClicked(memoryCard)
	{
		changeCutState(MUSDMethods.env_MemoryCard_mouseClicked,
				null,memoryCard,null);
	}

	pointcut MemoryCard_MemoryCard_reDraw(MemoryCard memoryCard):
		execution(void MemoryCard.reDraw(..))
		&& target(memoryCard) ;

	after(MemoryCard memoryCard):MemoryCard_MemoryCard_reDraw(memoryCard)
	{
		changeCutState(MUSDMethods.MemoryCard_MemoryCard_reDraw,
				memoryCard,memoryCard,null);
	}

	pointcut MemoryPanel_MemoryCard_flipUp(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipUp(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipUp(memoryPanel,memoryCard)
	{
		changeCutState(MUSDMethods.MemoryPanel_MemoryCard_flipUp,
				memoryPanel,memoryCard,null);
	}

	// MUSD Logic:
	protected void  changeActiveMUSDCutState(int MUSDm, Object sourceObject, Object targetObject,ActiveMUSDAspect activeMUSD,
		ArrayList args)
	{
		activeMUSD.setLineInstance(MemoryPanel_INST_memoryPanel,MUSDEnv.getLifeLineInstance("MemoryPanel"));

		switch (MUSDm)
		{
			case MUSDMethods.env_MemoryCard_mouseClicked:
				if(activeMUSD.instancesEquals(MemoryCard_INST_mc1,null)
					&& activeMUSD.isInCut(0,0,0))
				{
					activeMUSD.setLineInstance(MemoryCard_INST_mc1,targetObject);
					activeMUSD.setCut(1,1,0);
					if(evaluateCondition(1,activeMUSD))
					{
						activeMUSD.setCut(1,2,1);
						return;
					}
					break;
				}
				break;
			case MUSDMethods.MemoryCard_MemoryCard_reDraw:
				if(activeMUSD.instancesEquals(MemoryCard_INST_mc1,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc1,targetObject)
					&& activeMUSD.isInCut(1,3,2))
				{
					activeMUSD.setCut(1,4,2);
					break;
				}
				break;
			case MUSDMethods.MemoryPanel_MemoryCard_flipUp:
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc1,targetObject)
					&& activeMUSD.isInCut(1,2,1))
				{
					activeMUSD.setCut(1,3,2);
					return;
				}
				break;
			}
		if(activeMUSD.checkViolation())
			activeMUSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMUSDAspect activeMUSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryPanel memoryPanel = (MemoryPanel)activeMUSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		switch (conditionNumber)
		{
			case 1: 
				return !mc1.faceUp;
		}
		return false;
	}

	protected void getActiveMUSDCutState(MUSDMethodSet ME,MUSDMethodSet EE,
			MUSDMethodSet CV,MUSDMethodSet HV,ActiveMUSDAspect activeMUSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryPanel memoryPanel = (MemoryPanel)activeMUSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		MUSDMethod MUSDm2 = new MUSDMethod(null,mc1,
			MUSDMethods.env_MemoryCard_mouseClicked,null);// mouseClicked() Monitored
		MUSDMethod MUSDm3 = new MUSDMethod(mc1,mc1,
			MUSDMethods.MemoryCard_MemoryCard_reDraw,null);// reDraw() Execute
		MUSDMethod MUSDm4 = new MUSDMethod(memoryPanel,mc1,
			MUSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Execute

		 if(activeMUSD.isInCut(0,0,0))
		{
				ME.add(MUSDm2);
				CV.add(MUSDm4,MUSDm3);
				return;
		}
		 if(activeMUSD.isInCut(1,2,1))
		{
				EE.add(MUSDm4);
				CV.add(MUSDm3,MUSDm2);
				return;
		}
		 if(activeMUSD.isInCut(1,3,2))
		{
				EE.add(MUSDm3);
				CV.add(MUSDm4,MUSDm2);
				return;
		}
	}
}
