//  The file MUSDAspectMatch.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package memoryGame.aspects;

import memoryGame.classes.*;
import java.util.ArrayList;
import musd.runtime.lib.*;


public aspect MUSDAspectMatch extends MUSDAspect
{


	//Constants for instances, locations and varaibles
	static final int MemoryCard_INST_mc1 = 0;
	static final int MemoryCard_INST_mc2 = 1;
	static final int MemoryPanel_INST_memoryPanel = 2;


	MUSDAspectMatch()
	{
		addMinimalEvent(MUSDMethods.MemoryPanel_MemoryCard_flipUp);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 0;
	}

	//Pointcuts and advices:
	pointcut MemoryPanel_MemoryCard_flipDown(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipDown(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipDown(memoryPanel,memoryCard)
	{
		changeCutState(MUSDMethods.MemoryPanel_MemoryCard_flipDown,
				memoryPanel,memoryCard,null);
	}

	pointcut MemoryPanel_MemoryCard_flipUp(MemoryPanel memoryPanel, MemoryCard memoryCard):
		call(void MemoryCard.flipUp(..))
		&& target(memoryCard) && this(memoryPanel) ;

	after(MemoryPanel memoryPanel,MemoryCard memoryCard):MemoryPanel_MemoryCard_flipUp(memoryPanel,memoryCard)
	{
		changeCutState(MUSDMethods.MemoryPanel_MemoryCard_flipUp,
				memoryPanel,memoryCard,null);
	}

	pointcut MemoryPanel_MemoryPanel_soundBeep(MemoryPanel memoryPanel):
		execution(void MemoryPanel.soundBeep(..))
		&& target(memoryPanel) ;

	after(MemoryPanel memoryPanel):MemoryPanel_MemoryPanel_soundBeep(memoryPanel)
	{
		changeCutState(MUSDMethods.MemoryPanel_MemoryPanel_soundBeep,
				memoryPanel,memoryPanel,null);
	}

	// MUSD Logic:
	protected void  changeActiveMUSDCutState(int MUSDm, Object sourceObject, Object targetObject,ActiveMUSDAspect activeMUSD,
		ArrayList args)
	{
		activeMUSD.setLineInstance(MemoryPanel_INST_memoryPanel,MUSDEnv.getLifeLineInstance("MemoryPanel"));

		switch (MUSDm)
		{
			case MUSDMethods.MemoryPanel_MemoryCard_flipDown:
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc1,targetObject)
					&& activeMUSD.isInCut(2,2,4))
				{
					activeMUSD.setCut(3,2,5);
					return;
				}
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc2,targetObject)
					&& activeMUSD.isInCut(3,2,5))
				{
					activeMUSD.setCut(3,3,6);
					break;
				}
				break;
			case MUSDMethods.MemoryPanel_MemoryCard_flipUp:
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc1,null)
					&& activeMUSD.isInCut(0,0,0))
				{
					activeMUSD.setLineInstance(MemoryCard_INST_mc1,targetObject);
					activeMUSD.setCut(1,0,1);
					return;
				}
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryCard_INST_mc2,null)
					&& activeMUSD.isInCut(1,0,1))
				{
					activeMUSD.setLineInstance(MemoryCard_INST_mc2,targetObject);
					activeMUSD.setCut(1,1,2);
					return;
				}
				break;
			case MUSDMethods.MemoryPanel_MemoryPanel_soundBeep:
				if(activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,sourceObject)
					&& activeMUSD.instancesEquals(MemoryPanel_INST_memoryPanel,targetObject)
					&& activeMUSD.isInCut(1,1,2))
				{
					activeMUSD.setCut(1,1,3);
					if(evaluateCondition(5,activeMUSD))
					{
						activeMUSD.setCut(2,2,4);
						return;
					}
					break;
				}
				break;
			}
		if(activeMUSD.checkViolation())
			activeMUSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMUSDAspect activeMUSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryCard mc2 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc2);
		MemoryPanel memoryPanel = (MemoryPanel)activeMUSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		switch (conditionNumber)
		{
			case 5: 
				return !mc1.match(mc2);
		}
		return false;
	}

	protected void getActiveMUSDCutState(MUSDMethodSet ME,MUSDMethodSet EE,
			MUSDMethodSet CV,MUSDMethodSet HV,ActiveMUSDAspect activeMUSD)
	{
		MemoryCard mc1 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc1);
		MemoryCard mc2 = (MemoryCard)activeMUSD.getLineInstance(MemoryCard_INST_mc2);
		MemoryPanel memoryPanel = (MemoryPanel)activeMUSD.getLineInstance(MemoryPanel_INST_memoryPanel);

		MUSDMethod MUSDm5 = new MUSDMethod(memoryPanel,mc1,
			MUSDMethods.MemoryPanel_MemoryCard_flipDown,null);// flipDown() Execute
		MUSDMethod MUSDm6 = new MUSDMethod(memoryPanel,mc2,
			MUSDMethods.MemoryPanel_MemoryCard_flipDown,null);// flipDown() Execute
		MUSDMethod MUSDm7 = new MUSDMethod(memoryPanel,memoryPanel,
			MUSDMethods.MemoryPanel_MemoryPanel_soundBeep,null);// soundBeep() Execute
		MUSDMethod MUSDm8 = new MUSDMethod(memoryPanel,mc1,
			MUSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Monitored
		MUSDMethod MUSDm9 = new MUSDMethod(memoryPanel,mc2,
			MUSDMethods.MemoryPanel_MemoryCard_flipUp,null);// flipUp() Monitored

		 if(activeMUSD.isInCut(0,0,0))
		{
				ME.add(MUSDm8);
				CV.add(MUSDm9,MUSDm5,MUSDm6,MUSDm7);
				return;
		}
		 if(activeMUSD.isInCut(1,0,1))
		{
				ME.add(MUSDm9);
				CV.add(MUSDm5,MUSDm6,MUSDm7,MUSDm8);
				return;
		}
		 if(activeMUSD.isInCut(1,1,2))
		{
				EE.add(MUSDm7);
				CV.add(MUSDm9,MUSDm5,MUSDm6,MUSDm8);
				return;
		}
		 if(activeMUSD.isInCut(2,2,4))
		{
				EE.add(MUSDm5);
				CV.add(MUSDm9,MUSDm6,MUSDm7,MUSDm8);
				return;
		}
		 if(activeMUSD.isInCut(3,2,5))
		{
				EE.add(MUSDm6);
				CV.add(MUSDm9,MUSDm5,MUSDm7,MUSDm8);
				return;
		}
	}
}
